diff --git a/test/merge.abc.2.out b/test/merge.abc.2.out
new file mode 100644
index 000000000..8e3ebe837
--- /dev/null
+++ b/test/merge.abc.2.out
@@ -0,0 +1,58 @@
+##fileformat=VCFv4.1
+##FILTER=<ID=PASS,Description="All filters passed">
+##INFO=<ID=TEST,Number=1,Type=Integer,Description="Testing Tag">
+##FORMAT=<ID=TT,Number=A,Type=Integer,Description="Testing Tag, with commas and \"escapes\" and escaped escapes combined with \\\"quotes\\\\\"">
+##INFO=<ID=DP4,Number=4,Type=Integer,Description="# high-quality ref-forward bases, ref-reverse, alt-forward and alt-reverse bases">
+##FORMAT=<ID=GT,Number=1,Type=String,Description="Genotype">
+##FORMAT=<ID=GQ,Number=1,Type=Integer,Description="Genotype Quality">
+##FORMAT=<ID=DP,Number=1,Type=Integer,Description="Read Depth">
+##FORMAT=<ID=GL,Number=G,Type=Float,Description="Genotype Likelihood">
+##FILTER=<ID=q10,Description="Quality below 10">
+##FILTER=<ID=test,Description="Testing filter">
+##contig=<ID=1,assembly=b37,length=249250621>
+##contig=<ID=2,assembly=b37,length=249250621>
+##contig=<ID=3,assembly=b37,length=198022430>
+##contig=<ID=4,assembly=b37,length=191154276>
+##reference=file:///lustre/scratch105/projects/g1k/ref/main_project/human_g1k_v37.fasta
+##readme=AAAAAA
+##readme=BBBBBB
+##INFO=<ID=AC,Number=A,Type=Integer,Description="Allele count in genotypes">
+##INFO=<ID=AN,Number=1,Type=Integer,Description="Total number of alleles in called genotypes">
+##INFO=<ID=INDEL,Number=0,Type=Flag,Description="Indicates that the variant is an INDEL.">
+##INFO=<ID=STR,Number=1,Type=String,Description="Test string type">
+##INFO=<ID=DP,Number=1,Type=Integer,Description="Total Depth">
+##INFO=<ID=TXT,Number=.,Type=String,Description="Testing in INFO">
+##INFO=<ID=XRF,Number=R,Type=Float,Description="Test Number=AGR in INFO">
+##INFO=<ID=XAF,Number=A,Type=Float,Description="Test Number=AGR in INFO">
+##INFO=<ID=XGF,Number=G,Type=Float,Description="Test Number=AGR in INFO">
+##INFO=<ID=XRI,Number=R,Type=Integer,Description="Test Number=AGR in INFO">
+##INFO=<ID=XAI,Number=A,Type=Integer,Description="Test Number=AGR in INFO">
+##INFO=<ID=XGI,Number=G,Type=Integer,Description="Test Number=AGR in INFO">
+##INFO=<ID=XRS,Number=R,Type=String,Description="Test Number=AGR in INFO">
+##INFO=<ID=XAS,Number=A,Type=String,Description="Test Number=AGR in INFO">
+##INFO=<ID=XGS,Number=G,Type=String,Description="Test Number=AGR in INFO">
+##SAMPLE=<ID=NORMAL,SampleName=B,Description="Less-than (\"<\") and greater-than (\">\") quoting nonsense where double brackets would do just fine",softwareName=<Nonsense,Software>,softwareVer=<119,65>,softwareParam=<.>,MetadataResource=http://somewhere.com/path>
+##FORMAT=<ID=STR,Number=1,Type=String,Description="Testing string in format">
+##FILTER=<ID=q20,Description="Mapping quality below 20">
+##INFO=<ID=INTA,Number=A,Type=Integer,Description="Testing Number=A in INFO">
+#CHROM	POS	ID	REF	ALT	QUAL	FILTER	INFO	FORMAT	A	B	2:B	C	D
+1	3000150	.	C	T	59.2	PASS	AN=4;AC=2	GT:GQ	0/1:245	0/1:245	./.:.	./.:.	./.:.
+1	3000151	.	C	T	59.2	PASS	AN=4;AC=2	GT:DP:GQ	0/1:32:245	0/1:32:245	./.:.:.	./.:.:.	./.:.:.
+1	3062915	idSNP	G	T,C,A	419	test;q20	TEST=5;STR=.;DP=14;DP4=3,6,9,12;INTA=2,1,.;AN=9;AC=2,2,1	GT:TT:GQ:DP:GL:STR	0/1:0,1,.:409:35:-20,-5,-20,-20,-5,-20,.,.,.,.:.	2:0,1,.:409:35:-20,-5,-20,.:.	0/3:.:376:14:-10,.,.,.,.,.,0,.,.,-10:ABC	0/2:1,0,.:409:35:-20,-20,-20,-5,-5,-20,.,.,.,.:.	0/1:1,0,.:409:35:-20,-20,-20,-5,-5,-20,.,.,.,.:.
+1	3062915	id3D	GTTT	G	84.6	q10;q20	INDEL;STR=test;TXT=AA;DP=1013;DP4=6,7,8,9;AN=10;AC=5	GT:GQ:DP:GL	0/1:409:35:-20,-5,-20	0/1:409:35:-20,-5,-20	0/1:376:14:-10,0,-10	0/1:409:35:-20,-5,-20	0/1:409:35:-20,-5,-20
+1	3062915	id1D;id2D	GTT	GT,G	999	q20;q10	DP=14;DP4=2,4,6,8;AN=6;AC=1,2	GT:GQ:DP:GL:STR	./.:.:.:.:.	./.:.:.:.:.	0/1:376:14:-10,0,-10,.,.,.:DEF	0/2:409:35:-20,.,.,-5,.,-20:.	0/2:409:35:-20,.,.,-5,.,-20:.
+1	3106154	.	C	T	999	PASS	DP=15;AN=2;AC=1	GT:GQ:DP:GL	./.:.:.:.	./.:.:.:.	0/1:277:15:-10,0,-10	./.:.:.:.	./.:.:.:.
+1	3106154	.	CAAAA	CA,C	342	PASS	DP=15;AN=6;AC=2,1	GT:GQ:DP:GL	0/1:245:32:.	0/1:245:32:.	0/2:277:15:-10,.,.,0,.,-10	.:245:32:.	./.:245:32:.
+1	3106154	.	C	CT	459	PASS	AN=8;AC=4	GT:GQ:DP	0/1:245:32	0/1:245:32	./.:.:.	0/1:245:32	0/1:245:32
+1	3157410	.	G	T	46.7	q10	AN=4;AC=4	GT:GQ:DP	./.:.:.	./.:.:.	./.:.:.	1/1:21:21	1/1:21:21
+1	3157410	.	GAC	GC,G	90.6	PASS	DP=11;AN=6;AC=4,1	GT:GQ:DP	1/1:21:21	1/1:21:21	0/2:49:11	./.:.:.	./.:.:.
+1	3162006	.	GAA	G,GA	238	PASS	DP=19;XRF=1e+06,2e+06,500000;XRI=1111,2222,5555;XRS=AAA,BBB,DDD;XAF=1e+06,500000;XAI=1111,5555;XAS=AAA,DDD;XGF=1e+06,2e+06,3e+06,500000,.,9e+09;XGI=1111,2222,3333,5555,.,9999;XGS=A,B,C,E,.,F;AN=10;AC=3,2	GT:GQ:DP	0/1:212:22	0/1:212:22	0/1:589:19	0/2:212:22	0/2:212:22
+1	3177144	.	G	T	999	PASS	DP=24;AN=10;AC=3	GT:GQ:DP	0/0:150:30	1/1:150:30	0/1:236:24	0/0:150:30	0/0:150:30
+1	3177144	.	GT	G	999	PASS	DP=24;AN=6;AC=1	GT:GQ:DP	0/0:150:30	0/0:150:30	0/1:236:24	./.:.:.	./.:.:.
+1	3184885	.	TAAAA	TA,T	61.5	PASS	DP=16;AN=10;AC=5,4	GT:GQ:DP	1/2:12:10	1/2:12:10	0/1:435:16	1/2:12:10	1/2:12:10
+2	3188209	.	GA	G	41.5	PASS	DP=15;AN=2;AC=1	GT:GQ:DP	./.:.:.	./.:.:.	0/1:162:15	./.:.:.	./.:.:.
+2	3199812	.	G	GTT,GT	291	PASS	AN=8;AC=4,4	GT:GQ:DP	1/2:322:26	1/2:322:26	./.:.:.	1/2:322:26	1/2:322:26
+3	3199812	.	GA	GTT,GT	17.5	PASS	DP=19;AN=2;AC=1,1	GT:GQ:DP	./.:.:.	./.:.:.	1/2:188:19	./.:.:.	./.:.:.
+3	3212016	.	CTT	C,CT	79	PASS	AN=8;AC=4,4	GT:GQ:DP	1/2:91:26	1/2:91:26	./.:.:.	1/2:91:26	1/2:91:26
+4	3212016	.	CTT	C	999	q20	DP=15;AN=2;AC=1	GT:GQ:DP	./.:.:.	./.:.:.	0/1:158:15	./.:.:.	./.:.:.
+4	3258448	.	TACACACAC	T	.	PASS	AN=8;AC=4	GT:GQ:DP	0/1:325:31	0/1:325:31	./.:.:.	0/1:325:31	0/1:325:31
diff --git a/test/test.pl b/test/test.pl
index 26cd2a260..7ae244ad6 100755
--- a/test/test.pl
+++ b/test/test.pl
@@ -55,6 +55,7 @@
 test_vcf_isec($opts,in=>['isec.a','isec.b'],out=>'isec.ab.C.out',args=>'-C -c any');
 test_vcf_isec2($opts,vcf_in=>['isec.a'],tab_in=>'isec',out=>'isec.tab.out',args=>'');
 test_vcf_merge($opts,in=>['merge.a','merge.b','merge.c'],out=>'merge.abc.out',args=>'--force-samples');
+test_vcf_merge($opts,in=>['merge.a','merge.b','merge.c'],out=>'merge.abc.2.out',args=>'--force-samples -Fx');
 test_vcf_merge($opts,in=>['merge.2.a','merge.2.b'],out=>'merge.2.none.out',args=>'--force-samples -m none');
 test_vcf_merge($opts,in=>['merge.2.a','merge.2.b'],out=>'merge.2.both.out',args=>'--force-samples -m both');
 test_vcf_merge($opts,in=>['merge.2.a','merge.2.b'],out=>'merge.2.all.out',args=>'--force-samples -m all');
diff --git a/vcfmerge.c b/vcfmerge.c
index 66c26f23b..b216e8553 100644
--- a/vcfmerge.c
+++ b/vcfmerge.c
@@ -42,6 +42,9 @@ THE SOFTWARE.  */
 KHASH_MAP_INIT_STR(strdict, int)
 typedef khash_t(strdict) strdict_t;
 
+#define FLT_LOGIC_ADD    0
+#define FLT_LOGIC_REMOVE 1
+
 #define SKIP_DONE 1     // the record was processed
 #define SKIP_DIFF 2     // not compatible, merge later
 
@@ -131,7 +134,7 @@ typedef struct
     vcmp_t *vcmp;
     maux_t *maux;
     regidx_t *regs;    // apply regions only after the blocks are expanded
-    int header_only, collapse, output_type, force_samples, merge_by_id, do_gvcf;
+    int header_only, collapse, output_type, force_samples, merge_by_id, do_gvcf, filter_logic;
     char *header_fname, *output_fname, *regions_list, *info_rules, *file_list;
     info_rule_t *rules;
     int nrules;
@@ -807,6 +810,7 @@ void merge_chrom2qual(args_t *args, bcf1_t *out)
     {
         bcf1_t *line = maux_get_line(args, i);
         if ( !line ) continue;
+        bcf_unpack(line, BCF_UN_ALL);
 
         bcf_sr_t *reader = &files->readers[i];
         bcf_hdr_t *hdr = reader->header;
@@ -891,6 +895,24 @@ void merge_filter(args_t *args, bcf1_t *out)
     bcf_hdr_t *out_hdr = args->out_hdr;
 
     int i, ret;
+    if ( args->filter_logic == FLT_LOGIC_REMOVE )
+    {
+        for (i=0; i<files->nreaders; i++)
+        {
+            bcf1_t *line = maux_get_line(args, i);
+            if ( !line ) continue;
+            bcf_sr_t *reader = &files->readers[i];
+            bcf_hdr_t *hdr = reader->header;
+            if ( bcf_has_filter(hdr, line, "PASS") ) break;
+        }
+        if ( i<files->nreaders )
+        {
+            int flt_id = bcf_hdr_id2int(out_hdr, BCF_DT_ID, "PASS");
+            bcf_add_filter(out_hdr, out, flt_id);
+            return;
+        }
+    }
+
     khiter_t kitr;
     strdict_t *tmph = args->tmph;
     kh_clear(strdict, tmph);
@@ -903,7 +925,6 @@ void merge_filter(args_t *args, bcf1_t *out)
 
         bcf_sr_t *reader = &files->readers[i];
         bcf_hdr_t *hdr = reader->header;
-        bcf_unpack(line, BCF_UN_ALL);
 
         int k;
         for (k=0; k<line->d.n_flt; k++)
@@ -2287,6 +2308,7 @@ static void usage(void)
     fprintf(stderr, "        --print-header                 print only the merged header and exit\n");
     fprintf(stderr, "        --use-header <file>            use the provided header\n");
     fprintf(stderr, "    -f, --apply-filters <list>         require at least one of the listed FILTER strings (e.g. \"PASS,.\")\n");
+    fprintf(stderr, "    -F, --filter-logic <x|+>           remove filters if some input is PASS (\"x\"), or apply all filters (\"+\") [+]\n");
     fprintf(stderr, "    -g, --gvcf                         merge gVCF blocks, INFO/END tag is expected. Implies -i QS:sum,MinDP:min,I16:sum,IDV:max,IMF:max\n");
     fprintf(stderr, "    -i, --info-rules <tag:method,..>   rules for merging INFO fields (method is one of sum,avg,min,max,join) or \"-\" to turn off the default [DP:sum,DP4:sum]\n");
     fprintf(stderr, "    -l, --file-list <file>             read file names from the file\n");
@@ -2331,10 +2353,16 @@ int main_vcfmerge(int argc, char *argv[])
         {"regions-file",required_argument,NULL,'R'},
         {"info-rules",required_argument,NULL,'i'},
         {"no-version",no_argument,NULL,8},
+        {"filter-logic",required_argument,NULL,'F'},
         {NULL,0,NULL,0}
     };
-    while ((c = getopt_long(argc, argv, "hm:f:r:R:o:O:i:l:g",loptions,NULL)) >= 0) {
+    while ((c = getopt_long(argc, argv, "hm:f:r:R:o:O:i:l:gF:",loptions,NULL)) >= 0) {
         switch (c) {
+            case 'F': 
+                if ( !strcmp(optarg,"+") ) args->filter_logic = FLT_LOGIC_ADD;
+                else if ( !strcmp(optarg,"x") ) args->filter_logic = FLT_LOGIC_REMOVE;
+                else error("Filter logic not recognised: %s\n", optarg);
+                break;
             case 'g': args->do_gvcf = 1; break;
             case 'l': args->file_list = optarg; break;
             case 'i': args->info_rules = optarg; break;
